"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.oneOrMore = oneOrMore;
exports.optionally = optionally;
exports.zeroOrMore = zeroOrMore;
var _encoder = require("../encoder/encoder");
var _nodes = require("../utils/nodes");
function oneOrMore(sequence) {
  return {
    type: 'oneOrMore',
    children: (0, _nodes.asNodeArray)(sequence),
    encode: encodeOneOrMore
  };
}
function optionally(sequence) {
  return {
    type: 'optionally',
    children: (0, _nodes.asNodeArray)(sequence),
    encode: encodeOptionally
  };
}
function zeroOrMore(sequence) {
  return {
    type: 'zeroOrMore',
    children: (0, _nodes.asNodeArray)(sequence),
    encode: encodeZeroOrMore
  };
}
function encodeOneOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}+`
  };
}
function encodeOptionally() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}?`
  };
}
function encodeZeroOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}*`
  };
}
//# sourceMappingURL=quantifiers.js.map