import { encodeSequence } from '../encoder/encoder';
import { asNodeArray } from '../utils/nodes';
export function choiceOf(...alternatives) {
  if (alternatives.length === 0) {
    throw new Error('`choiceOf` should receive at least one alternative');
  }
  return {
    type: 'choiceOf',
    alternatives: alternatives.map(c => asNodeArray(c)),
    encode: encodeChoiceOf
  };
}
function encodeChoiceOf() {
  const encodedAlternatives = this.alternatives.map(c => encodeSequence(c));
  if (encodedAlternatives.length === 1) {
    return encodedAlternatives[0];
  }
  return {
    precedence: 'alternation',
    pattern: encodedAlternatives.map(n => n.pattern).join('|')
  };
}
//# sourceMappingURL=choice-of.js.map