import type { EncodeOutput } from '../encoder/types';
export interface CharacterClass {
    type: 'characterClass';
    characters: string[];
    ranges: CharacterRange[];
    isInverted: boolean;
    encode: () => EncodeOutput;
}
/**
 * Character range from start to end (inclusive).
 */
export interface CharacterRange {
    start: string;
    end: string;
}
export declare const any: CharacterClass;
export declare const digit: CharacterClass;
export declare const word: CharacterClass;
export declare const whitespace: CharacterClass;
export declare function characterClass(...elements: CharacterClass[]): CharacterClass;
export declare function characterRange(start: string, end: string): CharacterClass;
export declare function anyOf(characters: string): CharacterClass;
export declare function inverted(element: CharacterClass): CharacterClass;
//# sourceMappingURL=character-class.d.ts.map